pages/urls.py
from django.contrib import admin

from django.views.decorators.cache import cache_page

from django.urls import (
    path,
    re_path,
    include
)

from . import views

app_name = 'pages'

urlpatterns = [

    re_path(
        r'^$',
        views.HomeView.as_view(),
        name='home'),

    re_path(
        r'^contact/$',
        views.ContactView.as_view(),
        name='contact'),

    re_path(
        r'^about/$',
        views.AboutView.as_view(),
        name='about'),

    re_path(
        r'^properties/$',
        views.PropertyListView.as_view(),
        name='properties'),

    re_path(
        r'^video-banner/$',
        views.VideoBannerPartialView.as_view(),
        name='video-banner'),

    # re_path(
    #     r'^top-banner/(?P<page_name>\w+)/$',
    #     views.TopBanner.as_view(),
    #     name='top-banner'),
]

property/models.py
import secrets

from django.db import models
from django.utils.text import slugify
from django.utils.translation import ugettext_lazy as _

from django.urls import reverse

from django.core.validators import (
    FileExtensionValidator,
    RegexValidator
)

from painless.utils.upload.path import date_directory_path

from painless.utils.models.common import (
    TimeStampModelMixin,
    ImageModelMixin,
    TitleSlugLinkModelMixin
)


class Property(TitleSlugLinkModelMixin, ImageModelMixin, TimeStampModelMixin):
    STATUS = (
        ('r', _('Rent')),
        ('b', _('Buy'))
    )

    KIND = (
        ('a', _('apartment')),
        ('h', _('house')),
        ('g', _('ground'))
    )

    sku = models.CharField(_("SKU"), editable=False, max_length=7)

    price = models.CharField(
        _("Price"),
        max_length=16,
        validators=[
            RegexValidator(r'\d+', message=_('price must be digit.')),
        ]
    )
    is_featured = models.BooleanField(_("Is Featured"), default=False)
    is_popular = models.BooleanField(_("Is Popular"), default=False)

    status = models.CharField(_("Status"), choices=STATUS, max_length=1)
    kind = models.CharField(_("Kind"), choices=KIND, max_length=1)
    area = models.CharField(
        _("Area"),
        max_length=12,
        validators=[RegexValidator(r'\d+x\d+',
                                   message=_("Please enter area in this format `(100x200)`. TIP: (width, height) "))]
    )

    description = models.TextField(_("Description"))

    category = models.ForeignKey('Category', related_name='properties', on_delete=models.PROTECT)

    def save(self, *args, **kwargs):
        self.sku = secrets.token_hex(3).upper()
        self.slug = slugify(self.title, allow_unicode=True)
        super(Property, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('property', kwargs={'slug': self.slug})

    def __str__(self):
        return self.title

    class Meta:
        verbose_name = _('Property')
        verbose_name_plural = _('Properties')


class Category(TitleSlugLinkModelMixin, TimeStampModelMixin):
    class Meta:
        verbose_name = _('Category')
        verbose_name_plural = _('Categories')

    def save(self, *args, **kwargs):
        self.slug = slugify(self.title, allow_unicode=True)
        super(Category, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('property_category', kwargs={'slug': self.slug})

    def __str__(self):
        return self.title


class Tag(TitleSlugLinkModelMixin, TimeStampModelMixin):
    item = models.ManyToManyField("Property", db_column='property', related_name='tag', verbose_name=_("Tag Property"))

    def save(self, *args, **kwargs):
        self.slug = slugify(self.title, allow_unicode=True)
        super(Tag, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('property_tag', kwargs={'slug': self.slug})

    def __str__(self):
        return self.title


class Feature(TitleSlugLinkModelMixin, TimeStampModelMixin):
    item = models.ForeignKey(
        Property,
        db_column='property',
        verbose_name=_("Feature"),
        related_name='features',
        on_delete=models.CASCADE
    )

    icon = models.ForeignKey(
        'Icon',
        db_column='icon',
        verbose_name=_("Icon"),
        related_name='features',
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
    )

    def save(self, *args, **kwargs):
        self.slug = slugify(self.title, allow_unicode=True)
        super(Feature, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('property_feature', kwargs={'slug': self.slug})

    def __str__(self):
        return self.title


class Gallery(TimeStampModelMixin, ImageModelMixin):
    item = models.ForeignKey(Property, db_column='property', verbose_name=_("Feature"), related_name='pictures',
                             on_delete=models.CASCADE)

    def __str__(self):
        return self.alternate_text

    def get_absolute_url(self):
        return reverse('property_gallery', kwargs={'slug': self.slug})

    class Meta:
        verbose_name = _('Gallery')
        verbose_name_plural = _('Galleries')


class Amenities(TimeStampModelMixin):
    key = models.CharField(_("Key"), max_length=150)
    value = models.BooleanField(_("Value"))
    item = models.ForeignKey(Property, db_column='property', verbose_name=_("Amenities"), related_name='ameneties',
                             on_delete=models.CASCADE)

    def get_absolute_url(self):
        return reverse('property_aminity', kwargs={'slug': self.slug})

    def __str__(self):
        return self.key


class Detail(TimeStampModelMixin):
    key = models.CharField(_("Key"), max_length=150)
    value = models.CharField(_("Key"), max_length=150)
    item = models.ForeignKey(Property, db_column='property', verbose_name=_("Detail"), related_name='details',
                             on_delete=models.CASCADE)

    def get_absolute_url(self):
        return reverse('property_detail', kwargs={'slug': self.slug})

    def __str__(self):
        return self.key


class Icon(models.Model):
    name = models.CharField(
        max_length=30,
        verbose_name=_("Name"),
    )

    code = models.CharField(
        _("Code"),
        max_length=30,
    )
    
    def __str__(self):
        return self.name

media/templates/pages/about-us.html
{% extends 'shared/_base.html' %}
{% load static %}

{% block body %}

    <div class="banner">
        <div class="banner__content">
            <h4 class="banner__title text-center">{{ view.page_name }}</h4>
            <ul class="banner__breadcrumb list-inline text-center">
                <li class="list-inline-item">
                    <p><a href="{% url 'pages:home' %}">خانه</a></p>
                </li>
                <li class="divider list-inline-item">/</li>
                <li class="list-inline-item"><p>{{ view.page_name }}</p></li>
            </ul>
        </div>
    </div>

    <div class="find-houses section_padding">
        <div class="container">
            <div class="row">
                <div class="col-lg-6 col-12">
                    <h2 class="text-left mb-4 title_2">
                        درباره <span>{{ site.site_name }}</span>
                    </h2>
                    <h4 class="text-left mb-4">
                        <span>{{ site.about_us_title }}</span>
                    </h4>
                    <p class="mb-4">
                        {{ site.about_us }}
                    </p>

                    {#                <div class="d-flex mt-5 mb-5">#}
                    {#                    <a href="#" class="btn_1 button--moema">read More</a>#}
                    {#                    <br/>#}
                    {#                </div>#}

                </div>
                <div class="col-lg-6 col-12">
                    <img
                            class="img-fluid"
                            src="{{ site.about_us_pic.url }}"
                            alt="{{ site.about_us_alternate_text }}"
                    />
                </div>
            </div>
        </div>
    </div>
    <div class="our-services section_padding">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="section-title">
                        <h3>Our</h3>
                        <h2>خدمات</h2>
                    </div>
                </div>

                {% for service in services %}
                    <div class="col-md-4">
                        <div class="service">
                            <img src="{{ service.picture.url }}" alt="{{ service.picture_alternate_text }}"/>
                            <h3>{{ service.title }}</h3>
                            <p>
                                {{ service.description|truncatechars:100 }}
                            </p>
                        </div>
                    </div>
                {% endfor %}

            </div>
        </div>
    </div>

{% endblock %}

media/templates/pages/contact-us.html
{% extends 'shared/_base.html' %}
{% load static %}

{% block body %}

    <div class="banner">
        <div class="banner__content">
            <h4 class="banner__title text-center">{{ view.page_name }}</h4>
            <ul class="banner__breadcrumb list-inline text-center">
                <li class="list-inline-item">
                    <p><a href="{% url 'pages:home' %}">خانه</a></p>
                </li>
                <li class="divider list-inline-item">/</li>
                <li class="list-inline-item"><p>{{ view.page_name }}</p></li>
            </ul>
        </div>
    </div>

    <div class="contact-us section_padding">
        <div class="container">
            <div class="row">
                <div class="col-lg-8">
                    <h3 class="mb-4">{{ view.page_name }}</h3>
                    <form>
                        <div class="form-group">
                            <input
                                    type="text"
                                    class="form-control"
                                    id="exampleInputEmail1"
                                    aria-describedby="emailHelp"
                                    placeholder="First name"
                            />
                        </div>
                        <div class="form-group">
                            <input
                                    type="text"
                                    class="form-control"
                                    id="exampleInputEmail1"
                                    aria-describedby="emailHelp"
                                    placeholder="Last name"
                            />
                        </div>
                        <div class="form-group">
                            <input
                                    type="email"
                                    class="form-control"
                                    id="exampleInputEmail1"
                                    aria-describedby="emailHelp"
                                    placeholder="Email"
                            />
                        </div>
                        <div class="form-group">
                <textarea
                        class="form-control"
                        id="exampleFormControlTextarea1"
                        rows="4"
                        placeholder="Message"
                ></textarea>
                        </div>
                        <button type="submit" class="btn btn-primary">ارسال</button>
                    </form>
                </div>
                <div class="col-lg-4 call-info rtl">
                    <div class="call-info__content">
                        <h3 class="title_1 title_1--white">اطلاعات تماس</h3>
                        <p class="mb-4">
                            می توانید در ساعات کاری جهت ارتباط با شماره زیر تماس حاصل فرمایید!
                        </p>
                        <ul>
                            <li>
                                <p><i class="fas fa-phone-alt"></i> {{ site.phone_number }}</p>
                            </li>
                            <li>
                                <p>
                                    <i class="fas fa-map-marker-alt"></i> {{ site.address }}
                                </p>
                            </li>
                            <li>
                                <p><i class="fas fa-clock"></i>8 صیح الی 8 شب</p>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

media/templates/pages/index.html
{% extends 'shared/_base.html' %}
{% load static %}

{% load render_partial %}

{% block body %}

    {% render_partial 'pages:video-banner' %}

    {% if properties %}

        <div class="recently-properties section_padding">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="section-title section-title--orange">
                            <h3>Our</h3>
                            <h2>Services</h2>
                        </div>
                    </div>
                    {% for property in properties %}
                        <div class="col-lg-4 col-md-6">
                            <div class="project">
                                <div class="project__header">
                                    <img src="{{ property.picture.url }}" alt="{{ property.picture_alternate_text }}"/>
                                    <a href="#" class="badge badge--sale badge--top-right"
                                    >{{ property.get_status_display }}</a
                                    >
                                    <a href="#" class="badge badge--feature badge--top-left"
                                    >{{ property.get_kind_display }}</a
                                    >
                                    <a href="#" class="badge badge--family badge--bottom-left">
                                        {{ property.category }}
                                    </a>
                                    <div class="project__overlay">
                                        <a href="#">
                                            <h4>
                                                {{ property.title }}
                                                <br/>
                                                <span>جزئیات بیشتر</span>
                                            </h4>
                                        </a>
                                    </div>
                                </div>
                                <div class="project__content">
                                    <h3 class="project__content__title">
                                        <a href="#">{{ property.title }}</a>
                                    </h3>

                                    <ul class="project__content__details">
                                        {% for feature in property.features.all %}
                                            <li>
                                                <i class="{{ feature.icon.code }}" aria-hidden="true"></i>
                                                <span>{{ feature.title }}</span>
                                            </li>
                                        {% endfor %}
                                    </ul>

                                    <div class="project__content__properties">
                                        <h3>
                                            <a href="#">{{ property.price }}</a>
                                        </h3>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}

                    <div class="col-12 mb-4"></div>
                    <div class="col-12 text-center">
                        <a href="#" class="link-primary"
                        >View All <i class="fas fa-arrow-circle-right"></i
                        ></a>
                    </div>
                </div>
            </div>
        </div>

    {% endif %}

    <div class="welcome-to-find-houses section_padding">
        <div class="container">
            <div class="row">
                <div class="col-lg-6">
                    <h2 class="mb-2">خوش آمدید به <span>{{ site.site_name }}</span></h2>
                    <h4 class="mb-4">{{ site.welcome_title }}</h4>
                    <p class="mb-5">
                        <span>{{ site.site_name }}</span>
                        {{ site.welcome_summary }}
                    </p>
                    <ul>
                        {% for service in services %}
                            <li>
                                <img src="{{ service.picture.url }}" alt="{{ service.picture_alternate_text }}"/>
                                <div class="content">
                                    <h6>{{ service.title }}</h6>
                                    <p>
                                        {{ service.description|truncatechars:50 }}
                                    </p>
                                </div>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
                <div class="col-lg-6">
                    <img
                            class="img-fluid"
                            src="{{ site.picture.url }}"
                            alt=""
                    />
                </div>
            </div>
        </div>
    </div>

    <div class="popular-places section_padding">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="section-title section-title--orange">
                        <h3>Most</h3>
                        <h2>Popular places</h2>
                    </div>
                </div>

                {% if popularـproperties %}
                    {% for popular in popularـproperties %}
                        {% if forloop.first or forloop.last %}
                            <div class="col-lg-4 col-md-6">
                                <a class="hover-image" href="#">
                                    <div class="hover-image__content">
                                        {% if popular.is_featured %}
                                            <span class="featured">Featured</span>
                                        {% endif %}
                                        <img src="{{ popular.picture.url }}"
                                             alt="{{ popular.picture_alternate_text }}"/>
                                        <h4>
                                            {{ popular.title }}
                                            <br/>
                                            <span>{{ popular.status }}</span>
                                        </h4>
                                    </div>
                                </a>
                            </div>
                        {% else %}
                            <div class="col-lg-8 col-md-6">
                                <a class="hover-image" href="#">
                                    <div class="hover-image__content">
                                        {% if popular.is_featured %}
                                            <span class="featured">Featured</span>
                                        {% endif %}
                                        <img src="{{ popular.picture.url }}"
                                             alt="{{ popular.picture_alternate_text }}"/>
                                        <h4>
                                            {{ popular.title }}
                                            <br/>
                                            <span>{{ popular.status }}</span>
                                        </h4>
                                    </div>
                                </a>
                            </div>
                        {% endif %}
                    {% endfor %}
                {% endif %}

            </div>
        </div>
    </div>

{% endblock %}